BEGIN TRANSACTION;
-- drop table if already exists!

DROP TABLE IF EXISTS shooting_star_table_1,shooting_star_table_2,shortest_path_table_1,shortest_path_table_2;
/*===================================================
 shortest_path_astar
=====================================================*/
UPDATE roads SET reverse_cost=2*cost+1 WHERE sens='sens direct';

-- TEST N1 
SELECT * FROM shortest_path_astar('SELECT id, source, target,x1,y1,x2,y2,cost,reverse_cost from roads',37,43,true,true);
SELECT * FROM shortest_path_astar('SELECT id, source, target,x1,y1,x2,y2,cost,reverse_cost from roads',43,37,true,true);
 
CREATE TABLE shortest_path_astar_table_1(gid int4) with oids;
SELECT AddGeometryColumn( 'shortest_path_astar_table_1', 'the_geom', -1, 'MULTILINESTRING', 2 );
INSERT INTO shortest_path_astar_table_1(the_geom) 
	SELECT the_geom FROM astar_sp_directed('roads',37,43,true,true);
	
CREATE TABLE shortest_path_astar_table_2(gid int4) with oids;
SELECT AddGeometryColumn( 'shortest_path_astar_table_2', 'the_geom', -1, 'MULTILINESTRING', 2 );
INSERT INTO shortest_path_astar_table_2(the_geom) 
	SELECT the_geom FROM astar_sp_directed('roads',43,37,true,true);	
-- roads WHERE id IN
--	(SELECT edge_id FROM shortest_path_astar(
-- 'SELECT id, source, target, cost,reverse_cost from roads',
-- 37,43,true,true));

-- TEST N2  
SELECT * FROM shortest_path(
 'SELECT id, source, target, cost,reverse_cost from roads',
 43,37,true,true); 
 
CREATE TABLE shortest_path_table_2(gid int4) with oids;
SELECT AddGeometryColumn( 'shortest_path_table_2', 'the_geom', -1, 'MULTILINESTRING', 2 );
INSERT INTO shortest_path_table_2(the_geom) 
	SELECT the_geom FROM roads WHERE id IN
	(SELECT edge_id FROM shortest_path(
 'SELECT id, source, target, cost,reverse_cost from roads',
 37,43,true,true));

/*===================================================
 shortest_path_shooting_star()
=====================================================*/
UPDATE roads SET reverse_cost=-1 WHERE sens='sens direct';

-- TEST N1 
	SELECT * FROM shortest_path_shooting_star
	  (
     'SELECT id, source, target, cost,reverse_cost, x1, y1, x2, y2, rule, to_cost FROM roads',
     31,49,true,true
     );
     
CREATE TABLE shooting_star_table_1(gid int4) with oids;
SELECT AddGeometryColumn( 'shooting_star_table_1', 'the_geom', -1, 'MULTILINESTRING', 2 );
INSERT INTO shooting_star_table_1(the_geom) SELECT the_geom FROM roads WHERE id IN
(
	SELECT edge_id FROM shortest_path_shooting_star
	  (
     'SELECT id, source, target, cost,reverse_cost, x1, y1, x2, y2, rule, to_cost FROM roads',
     31,49,true,true
     )
);

-- TEST N2 

	SELECT * FROM shortest_path_shooting_star
	  (
     'SELECT id, source, target, cost,reverse_cost, x1, y1, x2, y2, rule, to_cost FROM roads',
     29,46,true,true
     );
     
CREATE TABLE shooting_star_table_2(gid int4) with oids;
SELECT AddGeometryColumn( 'shooting_star_table_2', 'the_geom', -1, 'MULTILINESTRING', 2 );
INSERT INTO shooting_star_table_2(the_geom) SELECT the_geom FROM roads WHERE id IN
(
	SELECT edge_id FROM shortest_path_shooting_star
	  (
     'SELECT id, source, target, cost,reverse_cost, x1, y1, x2, y2, rule, to_cost FROM roads',
     49,31,true,true
     )
);
/*
 shortest_path_shooting_star(): test 1
*/
SELECT edge_id FROM shortest_path_shooting_star(
    'SELECT id, source, target, cost,reverse_cost, x1, y1, x2, y2, rule, to_cost FROM roads',
     18,
      49,
      true, 
      true);
/*
 shortest_path_shooting_star(): test 2
*/
SELECT edge_id FROM shortest_path_shooting_star(
    'SELECT id, source, target, cost,reverse_cost, x1, y1, x2, y2, rule, to_cost FROM roads',
     49,
      18,
      true, 
      true);
/*
 shootingstar_sp(): test 1
*/
SELECT id,source,target from roads WHERE the_geom IN (
SELECT the_geom FROM shootingstar_sp(
    'roads',
     18,
      49,100000,'length',
      true, 
      true));
 
 
END TRANSACTION;